#include <math.h>
#include <defines.h>
/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: data.c      				             *
*  SubModules: Model to normalize data                       *
*  Super Module: title.c                                     *
**************************************************************/
extern float **data;
extern setup parameters;
extern nnet *net;

char normal[3][20] = {"None","Energy","Stats"};
char encode[4][20] = {"Class","Binary","Vector","Reserved"};
char prepro[4][20] = {"None","Radial","Conic","Reserved"};

energy_normalize()
{int i,j;
 float datum,energy;

 loopi(parameters.examplars+parameters.exam_test){
     energy = 0.0;
     loopj(parameters.input){
	  datum = data[i][j];
	  energy += (datum * datum);
			    }
	  energy = (float)sqrt((double)energy);
      if (energy == 0.0 ) energy = 1.0;


    loopj(parameters.input){
	   data[i][j] /= energy;
			   }
   }


}

stat_normalize()

{ int i,j;
  float mean,scatter,datum;
loopj(parameters.input){
    mean = 0.0;
							/*  calculate mean */
 loopi(parameters.examplars){ mean += data[i][j];}
					/* calculate variance or scatter */
 mean = mean/parameters.input;
				/* replace with deviation from mean */
 loopi(parameters.examplars+parameters.exam_test)
		      { data[i][j] += (-mean);}
 scatter= 0.0;
					     /* compute scatter */
 loopi(parameters.examplars){ scatter += (data[i][j]*
					  data[i][j]);}
 scatter = (float)sqrt((double)scatter);
					  /* replace with zscore */
 loopi(parameters.examplars+parameters.exam_test){
    data[i][j] = data[i][j]/scatter;}

}
}

do_normal()
{
 switch(parameters.snormal){
    case 0: break;
    case 1: energy_normalize();break;
    case 2: stat_normalize();break;
    }
}