/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*  NAME: Feedforward                                         *
*  MODULE NUMBER: 1.5                                        *
*  DESCRIPTION: Propagates data from the input to the output *
*  ALGORITHM: Standard feedforward rules                     *
*  Module: Feed 					     *
*  SubModules:  all paradigms packages.                      *
*  Super Module: title.c                                     *
**************************************************************/

#include <defines.h>
#include <math.h>

extern nnet *net;

extern int spcing,ctype;

extern int which_net,TEST,activ;
extern setup parameters;

/* A dummy function pointer is established (calc) then the
   routine FEED_FORWARD uses that pointer to find the location
   of the update rules.
*/



FEED_FORWARD()

{ int i,j;
float (* calc)();
loopj(parameters.layers){ calc = net->layer1[j]->propagate;
			  loopi(net->layer1[j]->size_output)
			      {net->layer1[j]->output[i]=
				    calc(net->layer1[j],i);}

			  }
}

