/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Percp:                                            *
*  Submodules: Just about all the rest.                      *
*  Main program loop for all feedforward models.	     *				     *
**************************************************************/

#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <defines.h>

long int count = 0;

int do_break = FALSE;

int do_fast = FALSE;

float randomx();

int good,right,display = 200;

/*  good and right keep track of the progress of the network
    good highest output is correct.
    right means all outputs are correct.
*/

nnet *net;
extern setup parameters;

/*   Main memory storage declaration for the net */
#define checkbreak if(do_break==ESC){free_all();return;}

void FEED_FORWARD(),TRAIN_NET(),do_count(),free_all(),percp_scn(),cover(),aboxer(),classes();

void percp()
{
      char choice;
      int i;

	percp_scn();
	init_window();
	INITIALIZE();
while(TRUE) {
	   MAKE_INPUT(net->inp,net->doft,-1);
	   FEED_FORWARD();
	   TRAIN_NET();
	   wait(display) {DO_TEST();DISPLAY_SCREEN();}
	   if(kbhit()){ menu();}
	   do_count(&count);
	   checkbreak;
	   }
free_all();
}


void FEED_FORWARD()

{ int i,j;
loopj(parameters.layers){  loopi(net->layer1[j]->size_output)
   {net->layer1[j]->output[i]=net->layer1[j]->propagate(net->layer1[j],i);}}
}


void TRAIN_NET()
{int i;
backward_loopi(parameters.layers)
   { net->layer1[i]->updater(net->layer1[i],net->layer1[i+1]);}
}


void do_count(count)
long *count;
{gotoxy(68,23);printf("%ld",*count);(*count)++;
if(do_fast) DISPLAY_SCREEN();

}
void free_all()
{
free_net();
free_data();
free_buffer();
do_break = FALSE;
}
void exitp(){ do_break = ESC;}

void percp_scn(){
cover();classes();
}
void cover()
{
 setbkcolor(DARKGRAY);
 setcolor(BLUE);
 setviewport(0,0,639,349,1);
 clearviewport();
 setlinestyle(0,0,3);
 rectangle(10,10,629,189);
 setcolor(LIGHTGRAY);
 rectangle(5,200,635,320);
 setlinestyle(0,0,1);
 settextstyle(2,0,4);
 #define col1 0
 #define col2 CYAN
 #define col3 YELLOW
 aboxer( 20,2,"Quit  ",col1,col2,col3);
 aboxer( 100,2,"Test  ",col1,col2,col3);
 do_train(FALSE);
 aboxer(300,2,"SAVE  ",col1,col2,col3);
 aboxer(400,2,"READ  ",col1,col2,col3);
 aboxer(500,2,"Parameters ",col1,col2,col3);
 aboxer(600,2,"HELP ",col1,col2,col3);

 }
void classes(){
 if(parameters.sencode != VECTOR){ aboxer(20,250,"Class ",BLUE,CYAN,YELLOW);
				   aboxer(20,280,"Called",BLUE,CYAN,YELLOW);}

 else  aboxer(20,280,"Error ",BLUE,CYAN,YELLOW);

 aboxer(20,220,"Example",BLUE,CYAN,YELLOW);
 show_config();
  }

void  aboxer(x,y,word,c1,c2,c3)
 int x,y,c1,c2,c3;
 char word[];
 { char junk4[5];int xx,yy,xx2,yy2;
   setcolor(c2);
   setfillstyle(1,c1);
   xx = x-5;
   yy = y;
   xx2 =x+strlen(word)*6+4;
   yy2 = y+11;
   setfillstyle(1,MY_BLACK);
   bar(xx+3,yy+3,xx2+3,yy2+3);
   setfillstyle(1,c1);
   bar(xx,y,xx2,yy2);
   setcolor(c2);
   rectangle(xx,yy,xx2,yy2);

   outtextxy(x,y,word);
   setcolor(c3);
   sprintf(junk4,"%c%c",word[0],0);
   outtextxy(x,y,junk4);
}
