
######################################################################
#
#  STUBWM.PL - a blank WM-specific code file for wmtheme
#

$wm_executable = 'stubmaker';
$unsupported{'activation'} = 1;
$unsupported{'renaming'} = 1;


  ###
  #
  #  WM_PROCESSCFG
  #
  ###

sub wm_processcfg {

  choke("Sorry, $programname does not support scanning for themes, yet.\n");
}

  ###
  #
  #  WM_QUERYDL
  #
  ###

sub wm_querydl {
  my $themetext = shift;

  choke("Sorry, $programname does not support downloading themes.");
}

  ###
  #
  #  WM_INSTALLTHEME
  #
  ###

sub wm_installtheme {
  my ($location, $filename, $defname) = @_;

  choke("Sorry, $programname does not support theme installation.");
}

  ###
  #
  #  WM_ACTIVATETHEME
  #
  ###

sub wm_activatetheme {
  my ($themename, $explicit) = @_;

  choke("Sorry, $programname does not support theme activation.")
    if $explicit;
}

  ###
  #
  #  WM_UNINSTALLTHEME
  #
  ###

sub wm_uninstalltheme {
  my $themename = shift;

  choke("Sorry, $programname does not support theme removal.");
}

  ###
  #
  #  WM_RENAME
  #
  ###

sub wm_rename {
  my ($old, $new) = @_;

  choke("Sorry, $programname does not support theme renaming.");
}

  ###
  #
  #  WM_VERSIONOK
  #
  ###

sub wm_versionok {
  1;
}

1;

