/*************************************************************************
*
*       DATE: 21 Febuary 1990
*       VERSION: 2
*
*       NAME: Trainnet
*       MODULE NUMBER: 1.6
*       DESCRIPTION: Using output, adjusts wights reduce error.
*       ALGORITHM: Werbos Multilayer Perceptron Backpropagation.
*       PASSED VARIABLES: None
*       RETURNS: None
*       GLOBAL VARIABLES USED: Weight Vectors
*       GLOBAL VARIABLES CHANGED: Weight Vectors
*       FILES READ: None
*       FILES WRITTEN: None
*       HARDWARE INPUT: None
*       HARDWARE OUTPUT: None
*       MODULES CALLED: None
*       CALLING MODULES: Main Loop
*
*       AUTHOR: Gregory L. Tarr
*       HISTORY:
*
*************************************************************************/

#include "defines.h"
extern nnet *net;
extern int do_train_it;
/*
float neta= 1.0;

float momentum=0.3;
 */
extern float neta,momentum;
extern int which_net,minimum,TEST,kclass[],ctype;
extern setup parameters;

extern float alpha,conscience,vigilence;
       float beta = 1.0;

TRAIN_NETx()
{int i,j,k,n;
neta = 1.0;
momentum = 0.3;
if(!do_train_it)return;
for(i=(parameters.layers-1);i>= 0;i--){
TRAIN_LAYER(net->layer1[i],net->layer1[i+1]);
}}
/*
dely(y,doft,del,output)

float y[],doft[],del[];
int output;
 { int i;
    loopi(output) { del[i] = (y[i]*(1.0-y[i]))*(doft[i]-y[i]);
         }  }
delx(x,del,del_down,w,upper,lower)
   float x[],del[],del_down[],w[];
   int upper;
 { float sum;
   int i,j;
loopj(lower){
   sum = 0.0;
   loopi(upper) { sum = sum + del[i] * w[i*upper+j];}
   sum = (x[j]*(1.0-x[j])) * sum;
   del_down[j] = sum;}
   }

*/
TRAIN_LAYER(l_on,l_up)
layer *l_on,*l_up;
/* l_on means the current layer, l_up means the layer above   */
{ int i,j,k,lower,upper;
  float neta2;
  lower = l_on->size_input;
  upper = l_on->size_output;
  neta2 = neta/(float)lower;
  if(l_on->output == net->outp)
  { dely(l_on->output,net->doft,l_on->delta,upper); }
else
  { delx(l_on->output,l_up->delta,l_on->delta,
         l_up->weights,l_up->size_output,upper); }

    loopj(upper) {
    l_on->theta[j] =  l_on->theta[j] + neta2 * l_on->delta[j] ;
    loopi(l_on->size_input) {
       l_on->momentum[j*lower+i] = (neta2 * l_on->delta[j] * l_on->input[i]
				 + momentum * l_on->momentum[j*lower+i])
                                 * l_on->mask[i];
      l_on->weights[j*lower+i] += l_on->momentum[j*lower+i];

               }}
}

