/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Saver:  Saves and Reads weigh files. 	     *
*  SubModules: None	           			     *
*  Super Module: menu.c title.c                              *
**************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <defines.h>

#define fline fprintf(fpp,"\n");

extern long int count;
extern setup parameters;
extern nnet *net;

read_weights(filename)
char filename[80];
{FILE *fpp;
int i,j,k;
float x,y;
int ninput,noutput,nlayers,nhide[10],values[10];
if(!strcmp(filename,"random")) {init_train();return;}
fpp = fopen(filename,"r");
if(fpp == NULL) exit(0);
fscanf(fpp,"%d %d %d %d",&noutput,&ninput,&nlayers,&parameters.train_rule);
loopi(nlayers) fscanf(fpp,"%d ",&nhide[i]);

parameters.input = ninput;
parameters.output = noutput;
parameters.layers = nlayers;
loopi(nlayers) parameters.hide[i] = nhide[i];

init_train();

values[0] = ninput;
for(i=1;i<nlayers;i++) values[i] = nhide[i-1];
values[nlayers]=noutput;

loopi(nlayers){
    loopk(values[i+1]){
      loopj(values[i]){ fscanf(fpp,"%f",&x);
		  net->layer1[i]->weights[k][j] = x;
		 }  }

      loopj(values[i+1]) {  fscanf(fpp,"%f ",&x);
                  net->layer1[i]->theta[j] = x;
			}}
fscanf(fpp,"%ld",&count);
}

/* Function to write out weight values to a file for later restoration */

write_weights (filename)
 char filename[20];
  { FILE *fpp;
    int i,j,k;
    fpp = fopen (filename,"wt");
    if(fpp == NULL){ printf("couldnt open file "); return;}

       fprintf (fpp,"%d %d %d %d \n",parameters.output,
				 parameters.input,
				 parameters.layers,
				 parameters.train_rule
				 );
loopi(parameters.layers)
      fprintf(fpp,"%d ",parameters.hide[i]);
	  fline;

       loopi(parameters.layers){
	  loopk(net->layer1[i]->size_output){
	      loopj(net->layer1[i]->size_input){
		   fprintf(fpp,"%f \n ",net->layer1[i]->weights[k][j]);}
		   fprintf(fpp,"\n");
		   }

	   loopj(net->layer1[i]->size_output){
		   fprintf(fpp,"%f \n",net->layer1[i]->theta[j]);}
	fline;}
		 fprintf(fpp,"%ld ",count);
	  fclose(fpp);
	  }


randomize_net()
{
init_train();
}