/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Screen.c : Screen hardware initialization         *
*  SubModules: None                                          *
*  Super Module: title.c                                     *
**************************************************************/

#include <graphics.h>
#define MY_BLACK 5

/* Hardware initialization for the graphics card.  */

make_screen()

{ int g_driver,g_mode,gerror;
  char choice;
   registerfarbgidriver(EGAVGA_driver_far);
   registerfarbgifont(triplex_font_far);
   registerfarbgifont(small_font_far);

   detectgraph(&g_driver,&g_mode);

   g_mode = EGAHI;
   initgraph(&g_driver,&g_mode,"");
   gerror = graphresult();
   if(gerror < 0){
	 printf("initgraph error: %s.\n",
			 grapherrormsg(gerror));
			 exit(1);}

setpalette(MY_BLACK,BLACK);
}

